#!/usr/bin/perl
##  Automatic Rule Generator for Mod_security
##
##  Copyright 2004 Stefano Di Paola <stefano.dipaola[at]wisec.it>
##
##  Released under GPL 2.0
##
##
##  Usage  modsecRXGen.pl ['domain']
##
use strict;
use utf8;
use DBI;
use Data::Dumper;
use RegExtract;
my $username="utente";
my $auth="password";
my @data;
my $url;
my $query;

 

my $path;
my %urlhash; # Hash{url=>Hash{variable=>regex}}
my $domain=$ARGV[0];
my $dbh = DBI->connect("DBI:mysql:database=htcheck;host=localhost;mysql_read_default_file=/etc/my.cnf",
		        $username, $auth ,{'RaiseError' => 1}) or die($!);
my $sql="select DISTINCT SUBSTRING_INDEX(url,'?',1),SUBSTRING(url,INSTR(url,'?')+1)  from Url where url like'%?%'";
my $sth = $dbh->prepare($sql);
$sth->execute()             # Execute the query
            or die "Couldn't execute statement: " . $sth->errstr;

          # Read the matching records and print them out          
while (@data = $sth->fetchrow_array()) {
      $url = $data[0];
      $query = $data[1];
      
       if(defined $query){
	   my @arrquery= split("&",$query);
	   
	   my %hashquery= map { split("=",$_) } @arrquery;
	   
      	  while( my ($qkey,$qval) = each (%hashquery) ){
	    if(defined $qval  && $url=~ /$domain/){
	    my $uri=$url;
	    $uri=~ s/http[s]?:\/\/([^\/]*)(.*)/$2/;
	     $urlhash{$uri}{$qkey}=RegExtract::get_matching_regex($urlhash{$path}{$qkey},$qval);
	     }
      	  }
       }
    }

 if ($sth->rows == 0) {
    $sth->finish;       
    my $rc  = $dbh->disconnect;
    die "No Urls '.\n\n";
 }

$sth->finish;
       
my $rc  = $dbh->disconnect;
 create_mod_security_rules(%urlhash);


sub create_mod_security_rules{
  my %hashreg=@_;
  while(my ($keyurl,$paramval ) =each %hashreg){
   if($keyurl ne ''){
    print "<Location $keyurl>\n";
    print "\tSecFilterInheritance On\n";
    while(my ($paramkey,$regval ) =each %{$paramval}){
      print "\tSecFilterSelective \"ARG_$paramkey\" \"!^".$regval->as_string."\$\" \n";
    } 
    print "</Location>\n"
    }
  }
}

